/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-controller-manager-msgs-0.7.3-0precise-20150327-1905/srv/ListControllers.srv
 *
 */


#ifndef CONTROLLER_MANAGER_MSGS_MESSAGE_LISTCONTROLLERSRESPONSE_H
#define CONTROLLER_MANAGER_MSGS_MESSAGE_LISTCONTROLLERSRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <controller_manager_msgs/ControllerState.h>

namespace controller_manager_msgs
{
template <class ContainerAllocator>
struct ListControllersResponse_
{
  typedef ListControllersResponse_<ContainerAllocator> Type;

  ListControllersResponse_()
    : controller()  {
    }
  ListControllersResponse_(const ContainerAllocator& _alloc)
    : controller(_alloc)  {
    }



   typedef std::vector< ::controller_manager_msgs::ControllerState_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::controller_manager_msgs::ControllerState_<ContainerAllocator> >::other >  _controller_type;
  _controller_type controller;




  typedef boost::shared_ptr< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct ListControllersResponse_

typedef ::controller_manager_msgs::ListControllersResponse_<std::allocator<void> > ListControllersResponse;

typedef boost::shared_ptr< ::controller_manager_msgs::ListControllersResponse > ListControllersResponsePtr;
typedef boost::shared_ptr< ::controller_manager_msgs::ListControllersResponse const> ListControllersResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace controller_manager_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'controller_manager_msgs': ['/tmp/buildd/ros-hydro-controller-manager-msgs-0.7.3-0precise-20150327-1905/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "12c85fca1984c8ec86264f3d00b938f2";
  }

  static const char* value(const ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x12c85fca1984c8ecULL;
  static const uint64_t static_value2 = 0x86264f3d00b938f2ULL;
};

template<class ContainerAllocator>
struct DataType< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "controller_manager_msgs/ListControllersResponse";
  }

  static const char* value(const ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ControllerState[] controller\n\
\n\
\n\
================================================================================\n\
MSG: controller_manager_msgs/ControllerState\n\
string name\n\
string state\n\
string type\n\
string hardware_interface\n\
string[] resources\n\
";
  }

  static const char* value(const ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.controller);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct ListControllersResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::controller_manager_msgs::ListControllersResponse_<ContainerAllocator>& v)
  {
    s << indent << "controller[]" << std::endl;
    for (size_t i = 0; i < v.controller.size(); ++i)
    {
      s << indent << "  controller[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::controller_manager_msgs::ControllerState_<ContainerAllocator> >::stream(s, indent + "    ", v.controller[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // CONTROLLER_MANAGER_MSGS_MESSAGE_LISTCONTROLLERSRESPONSE_H
